<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: pointer.php,v 1.11 2004/06/25 05:59:01 philips Exp $
 $Source: /tmp/maintain/modules/class/pointer.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


/*!
	@header Pointer Class
	Handles forward and reverse pointers

*/

class Pointer {
	var $id;
	var $ip; // this is an IP object
	var $hostname;
	var $type;
	var $ttl;
	var $zone;
	var $_enabled;

	//Built object
	var $object_history;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function Pointer ( $pointer_id = 0 ) {
		global $conf;

		$this->id = $pointer_id;

		if ($this->id) {
			$info = $this->get_info();
			$this->ip		= new IP($info->ip);
			$this->hostname		= $info->hostname;
			$this->type		= $info->type;
			$this->ttl		= $info->ttl;
			$this->zone		= $info->zone;
			$this->_enabled		= $info->enabled;
			$this->object_history	= new ObjectHistory('pointer',$pointer_id);
		}

	} // Pointer

	function get_info () {
		global $conf;

		$sql = "SELECT * FROM pointer WHERE id='$this->id'";
		$db_result = mysql_query($sql, $conf['dbh']);
		
		return mysql_fetch_object($db_result);
	} // get_info

	/*!
		@function get_zone_pointers
		@discussion get's pointers based on zone
	*/
	function get_zone_pointers($zone_id) {
		global $conf;

		$sql = "SELECT id FROM pointer WHERE zone='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_row($db_results)) {
			$results[] = new Pointer($r[0]);
		}

		return $results;

	} // get_zone_pointers

	/*!
		@function check_hostname
		@discussion based on the type of pointer does the 
			    needed checks on the hostname
	*/
	function check_hostname($name,$domain,$ip_int) {
		global $conf;

		//Is there a cname?
		$sql = "SELECT zone_cname.id FROM zone_cname,domain WHERE zone_cname.domain = domain.id AND domain.name LIKE '$domain' AND zone_cname.name LIKE '$name'";
		$db_results = mysql_query($sql, $conf['dbh']);

		if ($r = mysql_fetch_row($db_results)) {
			$link = "<a href=\"" . $conf['web_path'] . "/cname.php?action=show_cname&cname_id=" . $r[0] . "\">[ Show Cname ]</a>";
			$conf['error']->add_error('hostname', "Error there is already a CNAME with this name " . $link);
	} // if CNAME

		//Is there a forward pointer
		$sql = "SELECT id FROM pointer WHERE hostname LIKE '" . $name . $domain . "' AND ip='$ip_int' AND type='forward'";
		$db_results = mysql_query($sql, $conf['dbh']);
			
		if ($r = mysql_fetch_row($db_results)) {
			$link = "<a href=\"" . $conf['web_path'] . "/pointer.php?action=show_pointer&pointer_id=" . $r[0] . "\">[ Show Pointer ]</a>";
			$conf['error']->add_error('hostname',"There is already a forward Pointer with this name -> ip " . $link);
		} // if a PTR

	} // check_hostname

	/**
	* Checks to see if an IP is already in use by an A record or Rev PTR
	*
	* Ignores pointers with $this->id
	*
	* @return	null	Returns an error in $conf['error']
	* @access	public
	*/
	function check_ip($ip_int) {
		global $conf;

		// Ignore the current pointer
		$ignore_id = $this->id;
		// Check for a PTR record
		$sql = "SELECT id FROM pointer WHERE ip='$ip_int' AND id!='$ignore_id' AND type='reverse'";
		$db_results = mysql_query($sql, $conf['dbh']);
	

		if ($r = mysql_fetch_row($db_results)) {
			$link = "<a href=\"" . $conf['web_path'] . "/pointer.php?action=show_pointer&pointer_id=$r[0]\">[ Show Pointer ]</a>";
			$conf['error']->add_error('ip_addr', "IP Address already in use by a reverse pointer" . $link);
		}

	} // check_ip

	/*!
		@function create_pointer
		@discussion creates a forward or reverse pointer
	*/
	function create_pointer($hostname,$ip_int,$ttl,$type) {
		global $conf;
	
		$zone_id = $conf['zone']->id;

		$sql = "INSERT INTO pointer (hostname,ip,ttl,type,zone) VALUES ('$hostname','$ip_int','$ttl','$type','$zone_id')";
		$db_results = mysql_query($sql, $conf['dbh']);
		$pointer_id = mysql_insert_id($conf['dbh']);

		return $pointer_id;

	} // create_pointer

	/*!
		@function set_enabled
		@discussion enabled/disable requires zone perms
	*/
	function set_enabled($enabled) {
		$this->update_item('enabled',$enabled);
		$this->enabled = $enabled;
	} // set_enabled

	function update_ip ($ip) {
		$this->update_item('ip', $ip);
		$this->ip= $ip;
	} // update_ip

	function update_hostname ($hostname) {
		$this->update_item('hostname', $hostname);
		$this->hostname = $hostname;
	} // update_hostname

	function update_ttl ($ttl) {
		$this->update_item('ttl', $ttl);
		$this->ttl = $ttl;
	} // update_ttl

	function update_type ($type) {
		$this->update_item('type', $type);
		$this->type = $type;
	}

	function update_item ($type, $value) {
		global $conf;

		$sql = "UPDATE pointer SET $type='$value' WHERE id='$this->id'";
		$db_result = mysql_query($sql, $conf['dbh']);
	} // update_item

	function is_enabled() {
		return $this->_enabled;
	}

	/*!
		@function delete
		@discussion this functions deletes a pointer, requires access to parent zone
	*/
	function delete($pointer_id) {
		global $conf,$user;

		$pointer = new Pointer($pointer_id);

		// Delete the object
		$sql = "DELETE FROM pointer WHERE id='$pointer_id'";
		$db_results = mysql_query($sql, dbh());

		// Delete the object_history
		$sql = "DELETE FROM object_history WHERE type='pointer' AND object_id='$pointer_id'";
		$db_results = mysql_query($sql, dbh());

		// Add the deletion record
		$text = "Deleted " . $pointer->type . " pointer " . $pointer->hostname . " <--> " . $pointer->ip->ip_addr;
		$conf['ui']->add_delete_history($pointer->zone,$text,$user->username);

	} // delete
}

?>
